## Python - Table of contents

[Introduction](README.md)

- [C-4105L-TM Python Features](python_features/README.md)
  - [Objectives](python_features/objectives.md)
  - [Introduction to Python](python_features/python_intro.md)
  - [PyDocs & PEP8](python_features/pydocs_pep8.md)
  - [Objects](python_features/objects.md)
    - [Lab 1A](python_features/lab1a.md)
  - [Py2 vs Py3 Differences](python_features/py2_py3.md)
  - [Running Python](python_features/running_python.md)
- [C-4110L-TM Python Variables and Data Types](Data_Types/README.md)
  - [Objectives](Data_Types/objectives.md)
  - [Variables](Data_Types/variables.md)
    - [Lab 2A](Data_Types/lab2a.md)
  - [Numbers](Data_Types/numbers.md)
    - [Lab 2B & Lab 2C](Data_Types/lab2b_c.md)
  - [Strings](Data_Types/strings.md)
    - [Lab 2D & Lab 2E](Data_Types/lab2d_e.md)
  - [Lists](Data_Types/lists.md)
    - [Lab 2F & Lab 2G](Data_Types/lab2f_g.md)
  - [Bytes and Bytearray](Data_Types/byte_array.md)
  - [Tuples, range & buffer](Data_Types/tuples.md)
    - [Lab 2H](Data_Types/lab2h.md)
  - [Dictionaries & Sets](Data_Types/mapping.md)
    - [Lab 2I](Data_Types/lab2i.md)
- [C-4115L-TM Python Operators and Flow Control](Flow_Control/README.md)
  - [Objectives](Flow_Control/objectives.md)
  - [Operators](Flow_Control/operators.md)
  - [I/O Print](Flow_Control/io_print.md)
    - [Lab 3A](Flow_Control/lab3a.md)
  - [I/O: Files](Flow_Control/io_files.md)
    - [Lab 3B](Flow_Control/lab3b.md)
  - [If, Elif, Else](Flow_Control/if_elif_else.md)
    - [Lab 3C](Flow_Control/lab3c.md)
  - [While Loops](Flow_Control/while_loops.md)
    - [Lab 3D](Flow_Control/lab3d.md)
  - [For Loops](Flow_Control/for_loops.md)
    - [Lab 3E](Flow_Control/lab3e.md)
  - [Break and Continue](Flow_Control/break_continue.md)
    - [Lab 3F](Flow_Control/lab3f.md)
- [C-4120L-TM Python Functions](functions/README.md)
  - [Objectives](functions/objectives.md)
  - [Scope](functions/scope.md)
  - [User Functions](functions/user_functions.md)
    - [Lab 4A](functions/lab4a.md)
    - [Lab 4B](functions/lab4b.md)
  - [Lambda Functions](functions/lambda_functions.md)
    - [Lab 4C](functions/lab4c.md)
  - [List Comprehension](functions/list_comprehension.md)
    - [Lab 4D](functions/lab4d.md)
  - [Recursion](functions/recursion.md)
    - [Lab 4E](functions/lab4e.md)
  - [Closures, Iterators & Generators](functions/closures_iterators_generators.md)
- [C-4125L-TM Python Object Oriented Programming](oop/README.md)
  - [Objectives](oop/objectives.md)
  - [Tenets of OOP](oop/tenets_oop.md)
  - [Class Structure](oop/class_structure.md)
  - [Creating an Instance](oop/instance_creation.md)
  - [Getters/Setters](oop/getters_setters.md)
    - [Lab 5A](oop/lab5a.md)
  - [Inheritance](oop/parent_child_classes.md)
    - [Lab 5B](oop/lab5b.md)
  - [Polymorphism](oop/overloading_overriding.md)
  - [Composition](oop/composition.md)
    - [Lab 5C](oop/lab5c.md)
  - [Modules](oop/modules.md)
  - [Packages](oop/packages.md)
    - [Lab 5D](oop/lab5d.md)    
  - [Exceptions](oop/exceptions.md)
  - [Design Principles](oop/design_principles.md)
  - [OOP Terminology Review](oop/oop_terminology.md)

- [C-4130L-TM Python Algorithms](Algorithms/README.md)
  - [Objectives](Algorithms/objectives.md)
  - [Algorithms Analysis](Algorithms/Algorithm_Analysis.md)
  - [Algorithms Design](Algorithms/Algorithm_Design.md)
  - [Big O Notation](Algorithms/Big_O_notation.md)
  - [Big O Questions](Algorithms/Big_O_questions.md)
  - [Big O bounds and examples](Algorithms/Big_O_bounds_and_examples.md)
  - [Big O Demos](Algorithms/Big_O_Demos.md)
  - [Lab 6A Part One](Algorithms/Lab_6A_Part_One_Complexity_Exercises.md)
  - [Searching Algorithms](Algorithms/Searching_algorithms.md)
  - [Searching Algorithms Demos](Algorithms/Searching_algorithms_demos.md)
  - [Lab 6A Part Two](Algorithms/Lab_6A_Part_Two_Search_Exercises.md)
  - [Sorting Algorithms](Algorithms/Sorting_algorithms.md)
  - [Sorting Algorithms Demos](Algorithms/Sorting_algorithms_demos.md)
  - [Sort Faster Algorithm Demos](Algorithms/Sort_faster_algorithm_demos.md)
  - [Lab 6A Part Three](Algorithms/Lab_6A_Part_Three_Sort_Exercises.md)
  
- [C-4130L-TM Python Data Structures](Data_Structures/README.md)
  - [Objectives](Data_Structures/objectives.md)
  - [List Pointer Structures](Data_Structures/Lists_Pointer_Structures.md)
    - [Singly Linked List](Data_Structures/Singly_Linked_List.md)
    - [Singly Linked List Demonstration](Data_Structures/Singly_Linked_List_Demo.md)
    - [Lab 6B](Data_Structures/Lab_6B_Singly_Linked_List.md)
    - [Circularly Linked List](Data_Structures/Circularly_Linked_List.md)
    - [Doubly Linked List](Data_Structures/Doubly_Linked_List.md)
    - [Lab 6C](Data_Structures/Lab_6C_Doubly_and_Circularly_Linked_List.md)
  - [Stacks](Data_Structures/Stacks_Lesson.md)
  - [Stacks Implementation](Data_Structures/Stack_Implementation_Lesson.md)
  - [Queue](Data_Structures/Queue_Lesson.md)
    - [FIFO Queue](Data_Structures/FIFO_Queue.md)
    - [Lab 6D](Data_Structures/Lab_6D_Stack_and_Queue_Exercises.md)
    - [Case Study Super Market](Data_Structures/Case_Study_Queue_Supermarket.md)
    - [Case Study Emergency Room](Data_Structures/Case_Study_Queue_Emergency_Room.md)
  - [Trees](Data_Structures/Trees_Lessons.md)
    - [Trees Example](Data_Structures/Trees_Examples_Trees.md)
    - [Tree Led Demonstration](Data_Structures/Tree_Led_Demos.md)
    - [Lab 6E](Data_Structures/Trees_Perf_Labs.md)
    - [Trie Lesson](Data_Structures/Trie_Lesson.md)
    - [Trie Example](Data_Structures/Trie_Example.md)
  - [Hash Table](Data_Structures/Hash_Table.md)
- [C-4135L-TM Python Advanced Concepts](advanced/README.md)
  - [Objectives](Python/Advanced/objectives.md)
  - [Hangman Exercise Part I](advanced/hangman_part_i.md)
  - [Hangman Exercise Part II](advanced/hangman_part_ii.md)
  - [CTypes and Structures](advanced/ctypes.md)
  - [Regular Expressions](advanced/regular_expressions.md)
  - [Additional Libraries and Modules](advanced/additional_libraries_modules.md)
    - [JSON Lab Part I](advanced/lab_json_i.md)
    - [JSON Lab Part II](advanced/lab_json_ii.md)
  - [Multithreading](advanced/multithreading.md)
    - [Multithreading Lab](advanced/multithreading_lab.md)
  - [Unit Testing](advanced/unit_testing.md)
  - [Metaclasses](advanced/metaclasses.md)
  - [Design Patterns](advanced/designpatterns.md)
  - [Python Virtual Environment](advanced/virtualenv.md)

------------

[C-4105L-TM Python Features - Part I](python_features/part_i.md)
[C-4110L-TM Python Variables and Data Types - Part I](Data_Types/part_i.md)
[C-4115L-TM Python Operators and Flow Control - Part I](Flow_Control/part_i.md)
[C-4120L-TM Python Functions - Part I](functions/part_i.md)
[C-4125L-TM Python Object Oriented Programming - Part I](oop/part_i.md)
[C-4130L-TM Python Algorithms - Part I](Algorithms/part_i.md)
[C-4130L-TM Python Data Structures - Part I](Data_Structures/part_i.md)
[C-4135L-TM Python Advanced Concepts - Part I](Python/Advanced/part_i.md)